/*Kuki Szabolcs, cl. XII, Colegiul "Mihai Eminescu", Satu Mare, Judetul Satu Mare*/
/*	  		  	C A L U T I
				(25 puncte)

	Fie o tabla de dimensiune n*n, unde 3 <= n <=20, avand campurile
numerotate de la 1 la n*n. In colturi se afla doi cai albi, respectiv doi cai
negri.
      Sa se schimbe locurile cailor albi cu cei negri cu un numar MINIM de
mutari.
       Miscarea cailor este alternativa.

1. Se genreaza o solutie de ajungere a unui cal intr-un loc
2. Se verifica compatibilitatea cu a doua generare
3.
4.
5. Solutie momentana minima
*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#define NRMAXPAS 100

char pasi[NRMAXPAS][4][2];       //[nrpas][nrcal][0 = px; 1 = py]
char sol[NRMAXPAS][4][2];
int nrpasi;                                     //      5 6
int nrblk;                                      //     7   8
					       //        L
						 //    4   3
						   //   2 1

int nrpasmin=NRMAXPAS, nrpasan=0;
const char direcx[8]={1, -1, 2, -2, -1, 1, -2, 2},
	   direcy[8]={2, 2, 1, 1, -2, -2, -1, -1};

int n;  //dimensiunea tablei
char solutie=0;  // va deveni 1 cand se gaseste solutia


////Afisarea_tablei/////////////////////////////////////////////////////////////////////
void Afisarea_tablei(int nrpas)
{
char z1, z2;
printf("%d\n", nrpas);
for(z1=1; z1<=n; z1++)
{
 for(z2=1; z2<=n; z2++)
   if (pasi[nrpas][0][0]==z2 && pasi[nrpas][0][1]==z1) printf(" 0 ");
   else
   if (pasi[nrpas][1][0]==z2 && pasi[nrpas][1][1]==z1) printf(" 1 ");
   else
   if (pasi[nrpas][2][0]==z2 && pasi[nrpas][2][1]==z1) printf(" 2 ");
   else
   if (pasi[nrpas][3][0]==z2 && pasi[nrpas][3][1]==z1) printf(" 3 ");
   else printf(" x ");
printf("\n");
}
printf("\nApasati o tasta");
getch();
printf(".\n\n");
}  //end Afisarea_tablei

////Initializarea_datelor/////////////////////////////////////////////////////////////////////
void Initializarea_datelor(void)
{
int z1, z2;
pasi[0][0][0]=1, pasi[0][0][1]=1;
pasi[0][1][0]=n, pasi[0][1][1]=1;
pasi[0][2][0]=1, pasi[0][2][1]=n;
pasi[0][3][0]=n, pasi[0][3][1]=n;
//Afisarea_tablei(0);
}  //end Initializarea_datelor

////Shut_down/////////////////////////////////////////////////////////////////////
void Shut_down(void)
{
//printf("OK\n");
printf("									    ksz.");
exit(1);
}

////Introducerea_datelor/////////////////////////////////////////////////////////////////////
void Introducerea_datelor(void)
{
clrscr();
printf("Introduceti dimensiunea - n -  a tablei: ");scanf("%d", &n);

if (n<3 || n>20)
	{
	clrscr();
	printf("Dimensiunea tablei n trebuie sa fie un numar natural din intervalul [3, 20]\n");
	Shut_down();
	}
}  // end Introducerea_datelor

///Anterior/////////////////////////////////////////////////////////////////////
char Anterior(int px, int py, int nrpasc, int nrcal)
{
char ret=0;
int z=0;
while(ret==0 && z<nrpasc)
 if (pasi[z][nrcal][0]==px && pasi[z][nrcal][1]==py) ret=1;
 else z++;

return ret;
}  //end Anterior

////In_limite/////////////////////////////////////////////////////////////////////
char In_limit(int px, int py)
{
char ret=0;
if (px>0 && px<n+1 && py>0 && py<n+1) ret=1;
return ret;
}  //end In_limite

////Gasit/////////////////////////////////////////////////////////////////////
char Gasit(int px, int py, int ncal)
{
char ret=0;
if (ncal==0 && py==n && (px==n || px==1)) ret=1;
if (ncal==1 && py==n && (px==n || px==1)) ret=1;
if (ncal==2 && py==1 && (px==n || px==1)) ret=1;
if (ncal==3 && py==1 && (px==n || px==1)) ret=1;
return ret;
} //end Gasit

////Evidentiaza/////////////////////////////////////////////////////////////////////
void Evidentiaza(int px, int py, int nrpasc, int ncal)
{
pasi[nrpasc][ncal][0]=px; pasi[nrpasc][ncal][1]=py;
}  //Evidentiaza

////SEvidentiaza/////////////////////////////////////////////////////////////////////
void SEvidentiaza(int px, int py, int nrpasc, int ncal)
{
pasi[nrpasc][ncal][0]=0; pasi[nrpasc][ncal][1]=0;
}  //SEvidentiaza

////Anterior_alti_cai/////////////////////////////////////////////////////////////////////
char Anterior_alti_cai(int px, int py, int nrpasc, int ncal)
{
char ret=0;
if (ncal==1 &&
	((pasi[nrpasc][0][0]==px && pasi[nrpasc][0][1]==py) ||
	 (pasi[nrpasc][2][0]==px && pasi[nrpasc][2][1]==py))) ret=1;
if (ncal==2 &&
	((pasi[nrpasc][0][0]==px && pasi[nrpasc][0][1]==py) )) ret=1;
if (ncal==3 &&
	((pasi[nrpasc][0][0]==px && pasi[nrpasc][0][1]==py) ||
	 (pasi[nrpasc][2][0]==px && pasi[nrpasc][2][1]==py) ||
	 (pasi[nrpasc][1][0]==px && pasi[nrpasc][1][1]==py) )) ret=1;
return ret;
}   //end Anterior_alti_cai

////Sol_pos/////////////////////////////////////////////////////////////////////
void Sol_pos(void)
{
int z1, z2;
FILE *fileh;
solutie=1;
nrpasmin=nrpasan;
fileh=fopen("solutie", "w+");
fprintf(fileh, "    o        *        o        *\n");
for(z1=0; z1<nrpasmin; z1++)
 {
 fprintf(fileh, "%3d -%3d %3d -%3d %3d -%3d %3d -%3d\n",
  pasi[z1][0][0]+(pasi[z1][0][1]-1)*n, pasi[z1+1][0][0]+(pasi[z1+1][0][1]-1)*n,
  pasi[z1][2][0]+(pasi[z1][2][1]-1)*n, pasi[z1+1][2][0]+(pasi[z1+1][2][1]-1)*n,
  pasi[z1][1][0]+(pasi[z1][1][1]-1)*n, pasi[z1+1][1][0]+(pasi[z1+1][1][1]-1)*n,
  pasi[z1][3][0]+(pasi[z1][3][1]-1)*n, pasi[z1+1][3][0]+(pasi[z1+1][3][1]-1)*n);
/*printf("%3d-%3d %3d-%3d %3d-%3d %3d-%3d\n",
  pasi[z1][0][0]+(pasi[z1][0][1]-1)*n, pasi[z1+1][0][0]+(pasi[z1+1][0][1]-1)*n,
  pasi[z1][2][0]+(pasi[z1][2][1]-1)*n, pasi[z1+1][2][0]+(pasi[z1+1][2][1]-1)*n,
  pasi[z1][1][0]+(pasi[z1][1][1]-1)*n, pasi[z1+1][1][0]+(pasi[z1+1][1][1]-1)*n,
  pasi[z1][3][0]+(pasi[z1][3][1]-1)*n, pasi[z1+1][3][0]+(pasi[z1+1][3][1]-1)*n);
*/ }
fprintf(fileh, "%d", (nrpasmin)*4);
fclose(fileh);
//printf("\n\nSolutie: %d\n", nrpasmin);
//for(z1=0; z1<=nrpasmin; z1++) Afisarea_tablei(z1);
//printf("End sol\n");
} //end Sol_pos

////Cauta_drum_c4spre1_2/////////////////////////////////////////////////////////////////////
void Cauta_drum_c4spre1_2(int nrpasc)
{
int z, pxx, pyy;
if (nrpasc<=nrpasan && solutie==0)
for(z=0; z<8; z++)  //posibilitatile in care se poate muta
{
pxx=pasi[nrpasc-1][3][0]+direcx[z];
pyy=pasi[nrpasc-1][3][1]+direcy[z];
 if (In_limit(pxx, pyy)==1 &&
     Anterior(pxx, pyy, nrpasc, 3)==0 &&
     Anterior_alti_cai(pxx, pyy, nrpasc, 3)==0 )

  if (Gasit(pxx, pyy, 3))
	{
	Evidentiaza(pxx, pyy, nrpasc, 3);
//	Afisarea_tablei(nrpasc);
	if (nrpasc==nrpasan)
				Sol_pos();
	Cauta_drum_c4spre1_2(nrpasc+1);
	SEvidentiaza(pxx, pyy, nrpasc, 3);
	}
	else
	{
	Evidentiaza(pxx, pyy, nrpasc, 3);
//	Afisarea_tablei(nrpasc);
	Cauta_drum_c4spre1_2(nrpasc+1);
	SEvidentiaza(pxx, pyy, nrpasc, 3);
	}
}  //for 8
}  //end Cauta_drum_c4spre1_2

////Cauta_drum_c2spre3_4/////////////////////////////////////////////////////////////////////
void Cauta_drum_c2spre3_4(int nrpasc)
{
int z;
if (nrpasc<=nrpasan && solutie==0)
{

for(z=0; z<8; z++)  //posibilitatile in care se poate muta
 if (In_limit(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z])==1 &&
     Anterior(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z], nrpasc, 1)==0 &&
     Anterior_alti_cai(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z], nrpasc, 1)==0)

  if (Gasit(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z], 1))
	{
	Evidentiaza(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z], nrpasc, 1);
// la c4 Sol_pos();
//	Afisarea_tablei(nrpasc);
	if (nrpasc==nrpasan) Cauta_drum_c4spre1_2(1);
	Cauta_drum_c2spre3_4(nrpasc+1);
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}
	else
	{
	Evidentiaza(pasi[nrpasc-1][1][0]+direcx[z], pasi[nrpasc-1][1][1]+direcy[z], nrpasc, 1);
//	Afisarea_tablei(nrpasc);
	Cauta_drum_c2spre3_4(nrpasc+1);
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}
}
}  //end Cauta_drum_c2spre3_4


////Cauta_drum_c3spre1_2/////////////////////////////////////////////////////////////////////
void Cauta_drum_c3spre1_2(int nrpasc)
{
int z, pxx, pyy;
if (nrpasc<=nrpasan && solutie==0)
  for(z=0; z<8; z++)  //posibilitatile in care se poate muta
{
pxx=pasi[nrpasc-1][2][0]+direcx[z];
pyy=pasi[nrpasc-1][2][1]+direcy[z];
 if ( In_limit(pxx, pyy)==1 &&
      Anterior(pxx, pyy, nrpasc, 2)==0 &&
      Anterior_alti_cai(pxx, pyy, nrpasc, 2)==0)
  if (Gasit(pxx, pyy, 2))
	{
	Evidentiaza(pxx, pyy, nrpasc, 2);
// la c4 Sol_pos();
//	Afisarea_tablei(nrpasc);
	if (nrpasc==nrpasan) Cauta_drum_c2spre3_4(1);
	Cauta_drum_c3spre1_2(nrpasc+1);
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}
	else
	{
	Evidentiaza(pxx, pyy, nrpasc, 2);
//	Afisarea_tablei(nrpasc);
	Cauta_drum_c3spre1_2(nrpasc+1);
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}

}   //for 8
}  //end Cauta_drum_c3spre1_2

////Cauta_drum_c1spre3_4/////////////////////////////////////////////////////////////////////
void Cauta_drum_c1spre3_4(int nrpasc)
{
int z, pxx, pyy;
if (nrpasc<nrpasmin && solutie==0)
for(z=0; z<8; z++)  //posibilitatile in care se poate muta
{
pxx=pasi[nrpasc-1][0][0] + direcx[z];
pyy=pasi[nrpasc-1][0][1] + direcy[z];
 if (In_limit(pxx, pyy)==1  &&
     Anterior(pxx, pyy, nrpasc, 0)==0)

  if (Gasit(pxx, pyy, 0))
	{
	Evidentiaza(pxx, pyy, nrpasc, 0);
//	nrpasmin=nrpasc; //nrpasmin este numarul de pasi de pus in Copy_sol
	nrpasan=nrpasc;
// la c4 Sol_pos();
//	Afisarea_tablei(nrpasc);
	Cauta_drum_c3spre1_2(1);
	Cauta_drum_c1spre3_4(nrpasc+1);
	solutie=0;
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}
	else
	{
	Evidentiaza(pxx, pyy, nrpasc, 0);
//	Afisarea_tablei(nrpasc);
	Cauta_drum_c1spre3_4(nrpasc+1);
	SEvidentiaza(pasi[nrpasc-1][3][0]+direcx[z], pasi[nrpasc-1][3][1]+direcy[z], nrpasc, 3);
	}
} //end for 8
}  //end Cauta_drum_c1spre3_4

////Diviz4/////////////////////////////////////////////////////////////////////
void Diviz4(void)
{
int z, altr=-1;
pasi[1][0][0]=pasi[0][0][0]+2,
	pasi[1][0][1]=pasi[0][0][1]+1;
pasi[1][2][0]=pasi[0][2][0]+2,
	pasi[1][2][1]=pasi[0][2][1]-1;

pasi[2][0][0]=pasi[2 - 1][0][0]+altr,
	pasi[2][0][1]=pasi[2 - 1][0][1]+2,
pasi[2][2][0]=pasi[2 - 1][2][0]+altr,
	pasi[2][2][1]=pasi[2 - 1][2][1]-2;

for(z=6; z<=n-2; z+=2)
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-2,
 altr*=-1;

pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+2,
	pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+1,
pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+2,
	pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-1;

pasi[z/2+1][0][0]=pasi[z/2][0][0]-2,
	pasi[z/2+1][0][1]=pasi[z/2][0][1]+1,
pasi[z/2+1][2][0]=pasi[z/2][2][0]-2,
	pasi[z/2+1][2][1]=pasi[z/2][2][1]-1;
////////////////////////////
altr=-1;
pasi[1][1][0]=pasi[0][1][0]-2,
	pasi[1][1][1]=pasi[0][1][1]+1;
pasi[1][3][0]=pasi[0][3][0]-2,
	pasi[1][3][1]=pasi[0][3][1]-1;

pasi[2][1][0]=pasi[2 - 1][1][0]-altr,
	pasi[2][1][1]=pasi[2 - 1][1][1]+2,
pasi[2][3][0]=pasi[2 - 1][3][0]-altr,
	pasi[2][3][1]=pasi[2 - 1][3][1]-2;

for(z=6; z<=n-2; z+=2)
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-altr,
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-2,
 altr*=-1;

pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-2,
	pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+1,
pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-2,
	pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-1;

pasi[z/2+1][1][0]=pasi[z/2][1][0]+2,
	pasi[z/2+1][1][1]=pasi[z/2][1][1]+1,
pasi[z/2+1][3][0]=pasi[z/2][3][0]+2,
	pasi[z/2+1][3][1]=pasi[z/2][3][1]-1;

nrpasan=z/2+1;
Sol_pos();
}  //end Diviz4

////Diviz4_1/////////////////////////////////////////////////////////////////////
void Diviz4_1(void)
{
int z=2, altr=1;

 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,z=4;
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2;

for(z=6; z<n-4; z+=2)
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,
 altr*=-1;
altr=-1;
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,z+=2;
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2;

altr=-1;
 z=2;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]+altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,z=4;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]+altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2;

for(z=6; z<n-4; z+=2)
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]+altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,
 altr*=-1;
altr=1;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]+altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,z+=2;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]+altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2;

altr=1;
for(z=2; z<=n; z+=2)
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+altr,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-2,
 altr*=-1;

for(z=2; z<=n; z+=2)
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-altr,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-2,
 altr*=-1;

nrpasan=z/2-1;
Sol_pos();
}  //end Diviz4_1

////Diviz4_2/////////////////////////////////////////////////////////////////////
void Diviz4_2(void)
{
int z=2, altr=1;

for(z=2; z<n-3; z+=2)
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,
 altr*=-1;
 altr*=-1;
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2;
 pasi[z/2+1][0][0]=pasi[z/2][0][0]-2,
 pasi[z/2+1][0][1]=pasi[z/2][0][1]+1;

for(z=2; z<n-3; z+=2)
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,
 altr*=-1;
 altr*=-1;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2;
 pasi[z/2+1][1][0]=pasi[z/2][1][0]+2,
 pasi[z/2+1][1][1]=pasi[z/2][1][1]+1;

for(z=2; z<n-3; z+=2)
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+altr,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-2,
 altr*=-1;
 altr*=-1;
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+altr,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-2;
 pasi[z/2+1][2][0]=pasi[z/2][2][0]-2,
 pasi[z/2+1][2][1]=pasi[z/2][2][1]-1;

for(z=2; z<n-3; z+=2)
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-altr,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-2,
 altr*=-1;
 altr*=-1;
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-altr,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-2;
 pasi[z/2+1][3][0]=pasi[z/2][3][0]+2,
 pasi[z/2+1][3][1]=pasi[z/2][3][1]-1;

nrpasan=z/2+1;
Sol_pos();
}  //end Diviz4_2

////Diviz4_3/////////////////////////////////////////////////////////////////////
void Diviz4_3(void)
{
int z=2, altr=1;

altr=1;
for(z=2; z<n-1; z+=2)
 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+altr,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+2,
 altr*=-1;

 pasi[z/2][0][0]=pasi[z/2 - 1][0][0]+2,
 pasi[z/2][0][1]=pasi[z/2 - 1][0][1]+1;
 pasi[z/2+1][0][0]=pasi[z/2][0][0]-2,
 pasi[z/2+1][0][1]=pasi[z/2][0][1]+1;

altr=1;
for(z=2; z<n-1; z+=2)
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-altr,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+2,
 altr*=-1;
 pasi[z/2][1][0]=pasi[z/2 - 1][1][0]-2,
 pasi[z/2][1][1]=pasi[z/2 - 1][1][1]+1;
 pasi[z/2+1][1][0]=pasi[z/2][1][0]+2,
 pasi[z/2+1][1][1]=pasi[z/2][1][1]+1;

altr=1;
for(z=2; z<n-1; z+=2)
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+altr,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-2,
 altr*=-1;
 pasi[z/2][2][0]=pasi[z/2 - 1][2][0]+2,
 pasi[z/2][2][1]=pasi[z/2 - 1][2][1]-1;
 pasi[z/2+1][2][0]=pasi[z/2][2][0]-2,
 pasi[z/2+1][2][1]=pasi[z/2][2][1]-1;

altr=1;
for(z=2; z<n-1; z+=2)
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-altr,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-2,
 altr*=-1;
 pasi[z/2][3][0]=pasi[z/2 - 1][3][0]-2,
 pasi[z/2][3][1]=pasi[z/2 - 1][3][1]-1;
 pasi[z/2+1][3][0]=pasi[z/2][3][0]+2,
 pasi[z/2+1][3][1]=pasi[z/2][3][1]-1;

nrpasan=z/2+1;
Sol_pos();
}  //end Diviz4_2

////main/////////////////////////////////////////////////////////////////////
void main(void)
{
Introducerea_datelor();
Initializarea_datelor();
if (n<12) Cauta_drum_c1spre3_4(1);   //cauta mutarile prin care calul 1 ajunge in pozitia 2 sau 3, iar dupa ce a gasit o solutie se va cauta pentru c3 sa ajunga in pozitiile 1 sau 2 astfel incat sa nu intre in contradictie cu c1
else if (n%4==0) Diviz4();
else if (n%4==1) Diviz4_1();
else if (n%4==2) Diviz4_2();
else if (n%4==3) Diviz4_3();
}  //end main
