 // ---start---

 // Irina Christodorescu
 // clasa XI-a
 // liceul Adolfo Camarillo High School, Camarillo, California

 #include <stdio.h>
 #include <stdlib.h>

 int countstudents(int,int);
 int cmmdc(int,int);
 int clearstudents(int,int);

 int n;
 unsigned char s[50][50];

 int main()
 {
   int max,mi,mj,i,j,nrs,nrm=0;
   FILE *f;

   printf("Introduceti dimensiunea salii: ");
   scanf("%d",&n);

   for(i=0;i<50;i++) for(j=0;j<50;j++) s[i][j]=0;
   for(i=1;i<n-1;i++) for(j=1;j<n-1;j++) s[i][j]=1;
   nrs=(n-2)*(n-2);
   if((f=fopen("concurs.out","wt"))==NULL)
     {
       printf("Error in main[%d]: Cannot open CONCURS.OUT for writing!\n",__LINE__);
       return 1;
     }

   while(nrs>0)
     {
       int a;
       max=mi=mj=0;
       for(i=0;i<n;i++)
	 {
	   if(!s[i][0])
	     if((a=countstudents(i,0))>max) { max=a; mi=i; mj=0; }
	   if(!s[i][n-1])
	     if((a=countstudents(i,n-1))>max) { max=a; mi=i; mj=n-1; }
	 }
       for(i=0;i<n;i++)
	 {
	   if(!s[0][i])
	     if((a=countstudents(i,0))>max) { max=a; mi=0; mj=i; }
	   if(!s[n-1][i])
	     if((a=countstudents(i,n-1))>max) { max=a; mi=n-1; mj=i; }
	 }
       clearstudents(mi,mj);
       s[mi][mj]=2;
       nrs-=max;
       nrm++;
     }
   fprintf(f,"%d\n",nrm);
   for(i=0;i<n;i++)
     for(j=0;j<n;j++)
       if(s[i][j]==2)
	 fprintf(f,"%d %d\n",i+1,j+1);
   return 0;
 }

 int countstudents(int x, int y)
 {
   int i,j,nr=0;
   for(i=1;i<n-1;i++)
     for(j=1;j<n-1;j++)
       if(s[i][j]) if(cmmdc(abs(i-x),abs(j-y))==1) nr++;
   return nr;
 }

 int clearstudents(int x, int y)
 {
   int i,j;
   for(i=1;i<n-1;i++)
     for(j=1;j<n-1;j++)
       if(s[i][j]) if(cmmdc(abs(i-x),abs(j-y))==1) s[i][j]=0;
   return 0;
 }

 int cmmdc(int a, int b)
 {
   int r;
   if(a==b) r=a;
   else if(a==1||b==1) r=1;
   else if(a*b==0) r=a+b;
   else r=cmmdc(b,a%b);
   return r;
 }

 // ---end---

