{*
 *
 *  Etapa 4, problema 2
 *  Nume: Badoiu Mihai
 *  Clasa: 12
 *  Email: mihaib@lbi.ro
 *  URL: http://www.lbi.ro/~mihaib
 *  Liceu: Liceul de Informatica, Bucuresti
 *
 *}

const
	max=300;

var
	t: array[0..max] of word;
	n: integer;
	v: array[0..12] of record
		y,x1,x2: integer;
		end;
	fo: text;

procedure init;
var
	i, k: word;
begin
	k:=0;
	t[0]:=0;
	for i:=1 to max do
	begin
		inc(k,i);
		t[i]:=k;
		end;
end;

procedure add(k: integer);
var
	y: integer;
begin
	inc(n);
	y:=0;
	while t[y+1]<k do
		inc(y);
	v[n].y:=y+1;
	v[n].x1:=k-t[y];
	v[n].x2:=t[y+1]-k;
end;

procedure sort;
var
	i,j: integer;
begin
	for i:=1 to n do
		for j:=i+1 to n do
		if (v[i].y>v[j].y) or
		((v[i].y=v[j].y) and (v[i].x1>v[j].x1)) then
		begin
			v[0]:=v[i];
			v[i]:=v[j];
			v[j]:=v[0];
			end;
end;

function tr1:boolean;
begin
	tr1:=((v[1].x1=v[2].x1) and (v[1].x2=v[3].x2) and (v[2].y=v[3].y));
end;

function tr2:boolean;
begin
	tr2:=((v[1].y=v[2].y) and (v[1].x2=v[3].x2) and (v[2].x1=v[3].x1));
end;

function par1:boolean;
begin
	par1:=((v[1].y=v[2].y) and (v[1].x1=v[3].x1) and (v[2].x1=v[4].x1) and
		(v[3].y=v[4].y) and (v[2].x1-v[1].x1=v[3].y-v[1].y));
end;

function par2:boolean;
begin
	par2:=((v[1].y=v[2].y) and (v[1].x2=v[3].x2) and (v[2].x2=v[4].x2) and
		(v[3].y=v[4].y) and (v[2].x1-v[1].x1=v[3].y-v[1].y));
end;

function hex:boolean;
begin
	hex:=((v[1].y=v[2].y) and (v[3].y=v[4].y) and (v[5].y=v[6].y) and
		(v[1].x1=v[3].x1) and (v[2].x2=v[4].x2) and (v[3].x2=v[5].x2) and
		(v[4].x1=v[6].x1) and (v[2].x1-v[1].x1=v[3].y-v[1].y) and
		(v[2].x1-v[1].x1=v[6].x1-v[5].x1));
end;

procedure calcul;
begin
	sort;
	case n of
		3:
		begin
			if tr1 or tr2 then
				writeln(fo, 'sunt varfurile unui triunghi')
			else
				writeln(fo, 'nu sunt varfurile unei figuri acceptabile');
			end;
		4:
		begin
			if par1 or par2 then
				writeln(fo, 'sunt varfurile unui paralelogram')
			else
				writeln(fo, 'nu sunt varfurile unei figuri acceptabile');
			end;
		6:
		begin
			if hex then
				writeln(fo, 'sunt varfurile unui hexagon')
			else
				writeln(fo, 'nu sunt varfurile unei figuri acceptabile');
			end;
		else
			writeln(fo, 'nu sunt varfurile unei figuri acceptabile');
		end;
end;

procedure load;
var
	f: text;
	k: integer;
begin
	assign(f,'input.');
	reset(f);
	while not seekeof(f) do
	begin
		n:=0;
		while not seekeoln(f) do
		begin
			read(f,k);
			add(k);
			write(fo,k,' ');
			end;
		calcul;
		end;
	close(f);
end;

begin
	assign(fo, 'output.');
	rewrite(fo);
	init;
	load;
	close(fo);
end.


 ************************************************************************
 ***  Mihai Badoiu                         http://www.lbi.ro/~mihaib  ***
 ***  str. Albotei nr.7,bl.8/2 ap.11             mailto:mihaib@lbi.ro ***
 ***  Bucharest 71547, Romania                                        ***
 ************************************************************************
