uses Crt;

var
      N : Integer;
      A : array[1..20, 0..20] of Integer;

procedure Init;
var
  F : Text;
  I, J : Byte;
begin
  Assign(F, 'date.pas');
  Reset(F);
  ReadLn(F, N);
  for I := 1 to N do
  begin
    for J := 1 to N do Read(F, A[I, J]);
    ReadLn(F);
    A[I, 0] := N;
  end;
  A[N+1, 0] := 0;
  Close(F);
end;

var
  F : Text;
  CC, I1, I2 : Integer;

procedure Win(X1, Y1, X2, Y2, TC, TB : Integer);
begin
  Window(X1, Y1, X2, Y2);
  TextColor(TC);
  TextBackground(TB);
  ClrScr;
end;

procedure Show;
var
  I, J : Integer;
begin
  for I := 1 to N + 1 do
  begin
    win(I*6, 2, I*6 + 4, 23, 15, 0);
    gotoxy(2, 22);
    for J := 1 to A[I, 0] do begin TextColor(A[I, J]); Write(A[I, J]); gotoxy(2, WhereY - 1); end;
  end;
  Win(1, 25, 80, 25, 14, 1);
  Write(' Press any key for the next move');
end;

begin
  Init;
  Win(1, 1, 80, 25, 15, 3);

  Assign(F, 'moves.pas');
  Reset(F);
  while not Eof(F) do
  begin
    Show;
    Window(1, 1, 80, 25);
    gotoxy(I1*6, 24); TextColor(3); Write('');
    gotoxy(I2*6, 24); TextColor(3); Write('');
    ReadLn(F, CC, I1, I2);
    Dec(A[I1, 0]); Inc(A[I2, 0]);
    A[I2, A[I2, 0]] := A[I1, A[I1, 0] + 1];
    Window(1, 1, 80, 25);
    gotoxy(I1*6, 24); TextColor(14); Write('');
    gotoxy(I2*6, 24); TextColor(15); Write('');
    delay(150);
    if KeyPressed then if ReadKey = #27 then Halt;
  end;

  Close(F);
end.