{program realizat de Dondera Tiberiu, clasa a XI-a J, liceul
  Nicolae Balcescu, Pitesti}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program hanoitza_hanoitza;
type
  usol=array[1..3] of byte;
  matrix=array[1..10,1..11] of byte;
  bbpoint=^bbdata;
  bbdata=record
           m:matrix;
           f,g,h:word;
           mut:usol;
           tata,fiu,next,prev:bbpoint;
         end;
var
  fisin,fisout:text;
  n,i,j:integer;
  min:word;
  a,b,c:matrix;
  mutari:array[1..20000] of usol;
  care,select,suc,last,opened,closed,act:bbpoint;
  egale,inopen,apartine,gatasol:boolean;
  ho,mi,se,hund:word;

function solutie(p:matrix):boolean;
  var
    i,j:integer;
    bun:boolean;
  begin
    bun:=true;
    for i:=1 to n do
      for j:=1 to n do
        if p[i,j]<>n+1-i then bun:=false;
    solutie:=bun;
  end;

procedure dosol;
  var
    k,i,j:integer;
  begin
    k:=0;
    while select<>nil do begin
      inc(k);
      mutari[k]:=select^.mut;
      select:=select^.tata;
    end;
    for i:=k-1 downto 1 do
      writeln(fisout,mutari[i,1],' ',mutari[i,2],' ',mutari[i,3]);
    writeln(fisout,k-1);
    gatasol:=true;
  end;

function max(a,b:longint):word;
  begin
    if a>b then max:=a
           else max:=b;
  end;

function euristica(a:matrix):word;
  var
    zero,val,x,y:word;
    i,j,k,l,h,d:integer;
    mb:array[1..10,1..11] of boolean;
    modif:boolean;
  begin
    val:=0;
    for i:=1 to n do begin
      for j:=1 to n+1 do begin
        mb[i,j]:=(a[i,j]=n+1-i)and(j<>n+1);
      end;
    end;
    for i:=1 to n do begin
      for j:=1 to n do begin
        modif:=false;
        for k:=i+1 to n do
          if not mb[k,j] then modif:=true;
        if (mb[i,j])and(modif) then begin
           x:=0;
           for h:=1 to i-1 do
             if a[h,j]<>0 then inc(x);
          val:=val+max(x*x,1);
        end;
      end;
    end;
    for i:=n downto 1 do begin
      for j:=1 to n do begin
        if a[i,j]<>n+1-i then begin
          if a[i,j]=0 then begin
            inc(val,1);
          end         else begin
            modif:=false;
            k:=1;
            repeat
              l:=1;
              repeat
                if (a[k,l]=n+1-i)and(not mb[k,l]) then begin
                  mb[k,l]:=true;
                  x:=0;
                  modif:=true;
                  for h:=1 to k-1 do
                    if a[h,l]<>0 then inc(x);
                  y:=0;
                  for h:=1 to i-1 do
                    if a[h,j]<>0 then inc(y);
                  val:=val+(x+1)*(y+1);
                end;
                inc(l);
              until (l>n+1)or(modif);
              inc(k);
            until (k>n)or(modif);
          end; {else la a[i,j]=0}
        end; {if-ul cu a[i,j]<>n+1-i}
      end; {for j}
    end; {for i}
    euristica:=val;
  end;

procedure expandare;
  var
    ce,result:matrix;
    i,j,k,loc:integer;
    geul:word;
    bila,deunde,unde:byte;
  begin
    ce:=select^.m;
    geul:=select^.g;
    for deunde:=1 to n+1 do begin
      loc:=0;
      k:=1;
      repeat
        if ce[k,deunde]<>0 then loc:=k;
        inc(k);
      until (k>n)or(loc<>0);
      if loc<>0 then begin
        bila:=ce[loc,deunde]; {culoarea bilei pe care o mut...}
        for unde:=1 to n+1 do begin
          if (ce[1,unde]=0)and (unde<>deunde) then begin
            result:=ce;
            k:=1;
            while (k<n)and(ce[k+1,unde]=0) do
              inc(k);
            result[k,unde]:=result[loc,deunde];
            result[loc,deunde]:=0;
            new(suc);
            suc^.m:=result;
            suc^.mut[1]:=bila;
            suc^.mut[2]:=deunde;
            suc^.mut[3]:=unde;
            suc^.g:=geul+1;
            suc^.tata:=select;
            last:=opened;
            apartine:=false;
            inopen:=false;
            while (last<>nil)and(not apartine) do begin
              egale:=true;
              b:=suc^.m;
              c:=last^.m;
              for i:=1 to n do
                for j:=1 to n+1 do
                  if b[i,j]<>c[i,j] then egale:=false;
              if egale then begin
                apartine:=true;
                inopen:=true;
                care:=last;
              end;
              last:=last^.next;
            end;

            if not apartine then begin
              last:=closed;
              while (last<>nil)and(not apartine) do begin
                egale:=true;
                b:=suc^.m;
                c:=last^.m;
                for i:=1 to n do
                  for j:=1 to n+1 do
                    if b[i,j]<>c[i,j] then egale:=false;
                if egale then begin
                  apartine:=true;
                  care:=last;
                end;
                last:=last^.next;
              end; {while}
            end; {if not apartine}
            if apartine then begin
              if care^.g>suc^.g then begin
                care^.tata:=suc^.tata;
                care^.mut:=suc^.mut;
                care^.g:=suc^.g;
                care^.f:=care^.g+care^.h;
                if inopen then begin
                  if care=opened then begin {daca e primul element din opened}
                    if care^.next<>nil then care^.next^.prev:=nil;
                    opened:=care^.next;
                  end            else care^.prev^.next:=care^.next;
                  if care^.next<>nil then care^.next^.prev:=care^.prev;
                  closed^.prev:=care;
                  care^.next:=closed;
                  care^.prev:=nil;
                  closed:=care;
                end;
              end;
              dispose(suc);
            end  {if apartine...}  else begin
              suc^.h:=euristica(suc^.m);
              suc^.f:=suc^.g+suc^.h;
              closed^.prev:=suc;
              suc^.next:=closed;
              suc^.prev:=nil;
              closed:=suc;
            end;
          end; {if ce[unde,1]}
        end; {for unde}
      end; {if loc<>0}
    end; {for deunde}
  end; {procedure}

function coloana:boolean;
  var
    h,i,j,k,l,s:integer;
    num:word;
    dif:boolean;
    col:array[1..10] of integer;
  begin
    coloana:=false;
    h:=0;
    i:=1;
    repeat
      j:=1;
      dif:=true;
      repeat
        if (a[j,i]<>n+1-j)then begin
          dif:=false;
          inc(h);
          col[h]:=i;
        end;
        inc(j);
      until (j>n)or(not dif);
      inc(i);
    until (i>n)or(h>=2);
    if (h=1) then begin
      coloana:=true;
      i:=n;
      repeat
        dif:=(a[i,col[1]]<>n+1-i);
        dec(i);
      until (dif);
      inc(i);
       j:=1;
       k:=0;
       num:=0;
       dif:=false;
       repeat
         inc(k);
         if (i<>k) then begin
           if (k<>n+1) then begin
             writeln(fisout,a[1,k],' ',k,' ',n+1);
             inc(num);
             dif:=true;
           end;
           writeln(fisout,a[j,col[1]],' ',col[1],' ',k);
           inc(num);
           inc(j);
         end;
       until (j>i);
       k:=i;
       repeat
         for j:=1 to i do
           if a[j,col[1]]=k then l:=j;
         if (l>=col[1]) then inc(l);
         writeln(fisout,k,' ',l,' ',col[1]);
         inc(num);
         dec(k);
       until k=0;
       k:=0;
       j:=1;
       repeat
         inc(k);
         if (i<>k) then begin
           if a[1,k]<>0 then writeln(fisout,a[1,k],' ',n+1,' ',k);
           inc(num);
           inc(j);
         end;
       until (j>i);
       writeln(fisout,num);
    end;
  end;
begin
  assign(fisin,'date');
  reset(fisin);
  assign(fisout,'rez');
  rewrite(fisout);
  readln(fisin,n);
  for i:=1 to n do begin
    for j:=n downto 1 do
      read(fisin,a[j,i]);
    readln(fisin);
  end;
  close(fisin);
  new(closed);
  act:=closed;
  act^.m:=a;
  act^.g:=0;
  act^.h:=euristica(act^.m);
  act^.f:=act^.h;
  act^.next:=nil;
  act^.prev:=nil;
  act^.tata:=nil;
  gatasol:=coloana;
  while (not gatasol)and(closed<>nil) do begin
    min:=closed^.f;
    act:=closed^.next;
    select:=closed;
    while act<>nil do begin
      if act^.f<min then begin
        select:=act;
        min:=act^.f;
      end;
      act:=act^.next;
    end;
    if solutie(select^.m) then begin
      dosol;
    end;
    if not gatasol then begin
      expandare;
      if closed=select then begin
        closed:=closed^.next;
        closed^.prev:=nil;
      end  else begin
        select^.prev^.next:=select^.next;
      end;
      if select^.next<>nil then select^.next^.prev:=select^.prev;
      select^.next:=opened;
      if opened<>nil then opened^.prev:=select;
      opened:=select;
      opened^.prev:=nil;
    end;
  end;
  close(fisout);
end.
