/*Kuki Szabolcs, cl. XII -a, Colegiul "Mihai Eminescu", Satu Mare, Judetul Satu Mare*/
/*			NUMERE (30 puncte)
		     (mai simplu decat pare!)

Sa se determine toate numerele naturale n < 60.000 cu urmatoarea proprietate:
daca 1 < m < n si daca m este natural si prim cu n, atunci m este numar
prim.

Scrierea in fisierul "numsol" cu structura:

n1
n2
...
nk

unde ni sunt numerele cerute.


Timp de executie 10 secunde.*/
///////SOURCE//////////////////SOURCE//////////////////SOURCE//////////SOURCE//
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#define NMAXSOL 100
typedef long int LI;
LI nsolg=0;

/////////////////////////////////////////////////////////////////////////
char Prim(LI nrd)
{
char ret=1;
LI z1;
for(z1=2; z1<=(nrd/2) && ret; z1++)
 if ((nrd%z1)==0) ret=0;
return ret;
}

/////////////////////////////////////////////////////////////////////////
char Detp(LI n1, LI n2)
{
char ret=1;
LI z1;
for(z1=2; z1<=((n1>n2)?n2 : n1)/2 && ret; z1++)
 if ((n1%z1)==0 && (n2%z1)==0) ret=0;
return ret;
}

/////////////////////////////////////////////////////////////////////////
char Detn(LI n)
{
char ret=1;
LI z1;
for(z1=2; z1<n && ret; z1++)
 if (Detp(z1, n))
  if (Prim(z1)==0) ret=0;
return ret;
}

/////////////////////////////////////////////////////////////////////////
void main (void)
{
LI z1;
FILE *fileho;
if ((fileho=fopen("numsol", "wt"))==NULL)
	{
	 printf("Fisier inaccesibil. (probabil: read only, deschis, etc.. )\n Rezultatul este: 1, 2, 3, 4, 6, 8, 12, 18, 24, 30.\nDone.");
	 getch();
	 exit(1);
	}
clrscr();
for(z1=1; z1<NMAXSOL; z1++)
 if (Detn(z1))
	{
	 fprintf(fileho, "%d\n", z1);
	 printf("%5d, ", z1);
	 nsolg++;
	}

fclose(fileho);
printf("\nDone.\n");
getch();
}
